proc maxtoblock { {a} {rec {0}} } {
   incr rec
   if {$rec > 10} {return error}
   set r [maxcompo1 $a]
   if [string equal $r end] {return end}
   set op [lindex $r 0]
   set r [lrange $r 1 end]
   set name [newop $op [llength $r]]
   if {[llength $r] == 1} {
      set name2 [maxtoblock $r]
         if ![string equal $name2 end] {connect {} $name in $name2 out} {
            uplevel #0 set $name.in $r
         }
   } {
      set j 0
      foreach i $r {
         set name2 [maxtoblock $i]
         if ![string equal $name2 end] {connect {} $name in$j $name2 out} {
            uplevel #0 set $name.in$j [lindex $r $j]
         }
         incr j
      }
   }
   return $name
 } 

 proc domaximapart { {m} } {
    set t "display2d:false;partswitch:true;\n$m;"
    # return [string range [exec maxima << $t | tail -2  ] 6 end-7]
    return [string range [exec maxima -q << $t ] 43 end-7]
    #return [exec maxima --real-quiet << $t ]
 }

 #return a list in the form {operator arg1 arg2 ...}
 proc maxcompo1 { {a} } {

   set o [domaximapart part($a,0)]
   if [string equal \{\" [string range $o 0 1 ]] { set o [string range $o 2 end] }
   if [string equal \"\} [string range $o end-1 end]] { set o [string range $o 0 end-2] }

   set i 1
   while {![string equal [set k [domaximapart part($a,$i)]]  "end"]  & $i<40} {
 #     puts $i,$k
 #     flush stdout
 #     update
      lappend o $k
      incr i
   }
   if {$i>= 40} {return error}
   return $o
 }

 # Create a new bwise block for an operator with nin inputs
 proc newop { {op {+}} {nin {2}} {name {}} {in {in}} {out {out}} {width {40}} {height {}} {tags {}} {x {10}} {y {10}} } {
   if {$name == {}} {
      switch -- $op + {set name add} - {set name sub} \/ {set name div} * {set name mul} ^ {set name pow} default {set name $op}
      uplevel #0 {if {[info exists proccount] == "0"} {set proccount 0} ;}
      global proccount
      incr proccount
      append name 0$proccount
   }

   set inp "\{"
   set f  "\{set $name.$out \""
   if {$nin == 1} {
    append inp " in"
    append f  "\($op\(\$\{$name.in\})"
   } {
    append inp " in0"
    append f  " ( (\$\{$name.in0\})"
   }
   for {set i 1} {$i < $nin} {incr i} {
      append inp " in$i"
      append f  " $op (\$\{$name.in$i\})"
   }
   append f  ")\"\}"
   append inp " \} "
   puts   "$f $name $inp $out $width {} {} $x $y"

   eval "newproc $f $name $inp $out $width {} {} $x $y"
   return $name
 }

