#
 # Make a ten input maxima formula addition block
 #
 proc_toblock add10 {} add101 1400 100
 for {set i 1} {$i < 11} {incr i} { set add101.i${i} "0" }
 proc_toblock add10 {} add102 1000 100
 for {set i 1} {$i < 11} {incr i} { set add102.i${i} "0" }
 proc_toblock add10 {} add103 1400 300
 for {set i 1} {$i < 11} {incr i} { set add103.i${i} "0" }
 #
 # The output block which multiplies the final formula with the final volume, which has a name linked with the Run button
 #
 newproc {set mult11.out "((${mult11.a})*(${mult11.b}))"} mult11 {a b} out 40 {} {} 1400 100
 set mult11.b (1/10)
 connect {} add103 out mult11 a
 connect {} add102 out add103 i1
 connect {} add101 out add103 i2
 #
 # First column
 #
 # for {set i 1} {$i < 11} {incr i} { proc_toblock sinea [list {f 440*$i} {m 0} {a (1/$i)}] sine${i}_1 [expr 1400] [expr 50+75*$i] ;
 #  connect {} sine${i}_1 out add10 i[expr $i] }
 #
 # Second column
 #
 # for {set i 1} {$i < 11} {incr i} { proc_toblock sinea [list {f 440*$i} {m 0} {a (1/(1000*$i))}] sine${i}_2 [expr 1300] [expr 50+75*$i] ; connect {} sine${i}_2 out sine${i}_1 m }

proc sineexp {f a1 a2 e m} {
}

proc genfmarr1 {{n 10} {m 1}} {
 for {set j 1} {$j<=$m} {incr j} {
 
   for {set i 1} {$i <= $n} {incr i} { 
      if {$j == 1} {
         proc_toblock sineexp [eval "list {f 440*$i} {m 0} {a (1/$i)}"] sineexp${i}_1 [expr 1200] [expr 20+102*$i] ;
         connect {} sineexp${i}_1 out add101 i[expr $i]
         proc_toblock sineexp [eval "list {f 440*$i} {m 0} {a (1/$i)}"] sineexp${i}_2 [expr 800] [expr 20+102*$i] ;
         connect {} sineexp${i}_2 out add102 i[expr $i]
      } {
       proc_toblock sineexp [eval "list {f 440*($i+$j/500)} {m 0} {a (v/($j*1000*$i))}"] sineexp${i}_${j} [expr 1100-$j*100] [expr 20+102*$i]
         connect {} sineexp${i}_${j} out sineexp${i}_[expr $j-1] m 
      }
   }

   if {$j != 1} {
      for {set i 1} {$i < $n} {incr i} { uplevel #0 "set sine${i}_${j}.a \"(v/(1000*$i))\"" }
   }
 }
}

genfmarr1 10 1

 # Create entries with modulation formulas of first column (where v is the velocity of the keypress, [0,1])
 #
# toplevel .if1
# for {set i 1} {$i < 11} {incr i} { pack [entry .if1.e1$i -textvar sine${i}_2.a -width 16] -side top -expand 1 -fill x }
 #
 # Set the variables
 #
# for {set i 1} {$i < 11} {incr i} { set sine${i}_2.a "(v/(2000*$i))" }
# wm title .if1 "sine_2"

 wm geom . 1055x653

 for {set i 1} {$i < 11} {incr i} { set sineexp${i}_1.f "(440*$i)" }
 for {set i 1} {$i < 11} {incr i} { set sineexp${i}_1.a1 "(1-((v+1/2)^2)/(9/4))" }
 for {set i 1} {$i < 11} {incr i} { set sineexp${i}_1.a2 "1/($i)" }
 for {set i 1} {$i < 11} {incr i} { set sineexp${i}_1.e "(1+$i)*2" }

 for {set i 1} {$i < 11} {incr i} { set sineexp${i}_2.f "(444*$i-($i/4))" }
 for {set i 1} {$i < 11} {incr i} { set sineexp${i}_2.a1 "(((v+1/2)^2)/(9/4))" }
 for {set i 1} {$i < 11} {incr i} { set sineexp${i}_2.a2 "1/(1+7*($i-1))" }
 for {set i 1} {$i < 11} {incr i} { set sineexp${i}_2.e "(1+$i)/2" }


